android - studio - floating button onclicklistener



InflateException avec FloatingActionButton de la bibliothèque de design officiel (5)

Je reçois un bogue lors de l'utilisation du FloatingActionButton officiel FloatingActionButton de la bibliothèque de concepteurs de Google.

Voici mon LogCat.

android.view.InflateException: Binary XML file line #34: Error inflating class android.support.design.widget.FloatingActionButton
at android.view.LayoutInflater.createView(LayoutInflater.java:633)
at android.view.LayoutInflater.createViewFromTag(LayoutInflater.java:743)
at android.view.LayoutInflater.rInflate(LayoutInflater.java:806)
at android.view.LayoutInflater.rInflate(LayoutInflater.java:809)
at android.view.LayoutInflater.inflate(LayoutInflater.java:504)
at de.robv.android.xposed.XposedBridge.invokeOriginalMethodNative(Native Method)
at de.robv.android.xposed.XposedBridge.handleHookedMethod(XposedBridge.java:655)
at android.view.LayoutInflater.inflate(Unknown Source)
at android.view.LayoutInflater.inflate(LayoutInflater.java:414)
at ---.---.com.---.SubCategoryFragment.onCreateView(SubCategoryFragment.java:47)
at android.support.v4.app.Fragment.performCreateView(Fragment.java:1789)
at android.support.v4.app.FragmentManagerImpl.moveToState(FragmentManager.java:955)
at android.support.v4.app.FragmentManagerImpl.moveToState(FragmentManager.java:1138)
at android.support.v4.app.BackStackRecord.run(BackStackRecord.java:740)
at android.support.v4.app.FragmentManagerImpl.execPendingActions(FragmentManager.java:1501)
at android.support.v4.app.FragmentManagerImpl$1.run(FragmentManager.java:458)
at android.os.Handler.handleCallback(Handler.java:739)
at android.os.Handler.dispatchMessage(Handler.java:95)
at android.os.Looper.loop(Looper.java:135)
at android.app.ActivityThread.main(ActivityThread.java:5221)
at java.lang.reflect.Method.invoke(Native Method)
at java.lang.reflect.Method.invoke(Method.java:372)
at com.android.internal.os.ZygoteInit$MethodAndArgsCaller.run(ZygoteInit.java:899)
at com.android.internal.os.ZygoteInit.main(ZygoteInit.java:694)
at de.robv.android.xposed.XposedBridge.main(XposedBridge.java:117)
Caused by: java.lang.reflect.InvocationTargetException
at java.lang.reflect.Constructor.newInstance(Native Method)
at java.lang.reflect.Constructor.newInstance(Constructor.java:288)
at android.view.LayoutInflater.createView(LayoutInflater.java:607)
... 24 more
Caused by: java.lang.NullPointerException: Attempt to invoke virtual method 'android.graphics.drawable.Drawable android.graphics.drawable.Drawable$ConstantState.newDrawable()' on a null object reference
at android.graphics.drawable.LayerDrawable$ChildDrawable.<init>(LayerDrawable.java:968)
at android.graphics.drawable.LayerDrawable$LayerState.<init>(LayerDrawable.java:1014)
at android.graphics.drawable.RippleDrawable$RippleState.<init>(RippleDrawable.java:910)
at android.graphics.drawable.RippleDrawable.createConstantState(RippleDrawable.java:901)
at android.graphics.drawable.RippleDrawable.createConstantState(RippleDrawable.java:90)
at android.graphics.drawable.LayerDrawable.mutate(LayerDrawable.java:932)
at android.graphics.drawable.RippleDrawable.mutate(RippleDrawable.java:891)
at android.view.View.applyBackgroundTint(View.java:16324)
at android.view.View.setBackgroundDrawable(View.java:16193)
at android.support.design.widget.FloatingActionButton.access$201(FloatingActionButton.java:56)
at android.support.design.widget.FloatingActionButton$1.setBackgroundDrawable(FloatingActionButton.java:118)
at android.support.design.widget.FloatingActionButtonLollipop.setBackgroundDrawable(FloatingActionButtonLollipop.java:75)
at android.support.design.widget.FloatingActionButton.<init>(FloatingActionButton.java:131)
at android.support.design.widget.FloatingActionButton.<init>(FloatingActionButton.java:79)
... 27 more

La seule ligne qui pointe vers mon application est l'endroit où elle gonfle le fichier xml et la ligne de ce fichier qui est mon FloatingActionButton .

   <android.support.design.widget.FloatingActionButton
        android:id="@+id/myFABSubCat"
        android:layout_width="wrap_content"
        android:layout_height="wrap_content"
        android:layout_alignParentBottom="true"
        android:layout_alignParentEnd="true"
        android:layout_alignParentRight="true"
        android:layout_margin="16dp"
        android:backgroundTint="@color/accent"
        android:src="@drawable/add_icon"
        app:borderWidth="0dp"
        app:elevation="4sp" />

Informaitons supplémentaires:

Voici le thème de mon application:

<resources>

    <!-- Base application theme. -->
    <style name="MBTIAppTheme" parent="Theme.AppCompat.Light.NoActionBar">
        <item name="colorPrimary">@color/primary</item>
        <item name="colorPrimaryDark">@color/primaryDark</item>
        <item name="colorAccent">@color/accent</item>
        <item name="android:windowContentOverlay">@null</item>
    </style>

    <style name="ThemeNoActionBar" parent="MBTIAppTheme">
        <item name="windowActionBar">false</item>
    </style>

</resources>

Oui, j'utilise un AppCompatActivity .

J'ai remarqué que j'utilise une ancienne version d'appcompat:

com.android.support:appcompat-v7:22.1.1

Cela semble être à jour:

compile 'com.android.support:design:22.2.0'

Aussi,

minSdkVersion 16
targetSdkVersion 22

Maintenant, je règle la visibilité sur GONE dans certains cas pour mon FAB, mais cela se produit après le gonflement, de sorte que cela ne peut pas être le problème.

Maintenant, cela fonctionne avec mon appareil 5.1, mais les utilisateurs qui ont des problèmes ont 5.0.

Est-ce un bug connu ou peut-être que je fais quelque chose de mal?

https://code.i-harness.com


Il suffit de changer android pour app :

android:backgroundTint="@color/accent"

À:

app:backgroundTint="@color/accent"

Il suffit de remplacer

<android.support.design.widget.FloatingActionButton 
...
...
android:backgroundTint
/>

à

<android.support.design.widget.FloatingActionButton 
...
...
app:backgroundTint
/>

Si vous avez accidentellement spécifié différentes versions de la bibliothèque appcompat dans différents modules, vous pouvez également obtenir ce message. Cela est susceptible de se produire lorsque vous créez un nouveau module, car Android Studio utilise par défaut la version la plus récente.

Pour savoir comment gérer cela dans des projets multi-modules, voir: Dans Gradle, comment déclarer des dépendances communes à un seul endroit?


Si vous utilisez un VectorDrawableCompat (ressource vectorielle), vous devez utiliser:

app:srcCompat="@drawable/x"

au lieu de:

android:src="@drawable/x"

com.android.support:appcompat-v7:21+ ajouté le support pour la teinte des widgets sur les appareils fonctionnant sous Android 5.1 (API niveau 21). Pour l'utiliser, assurez-vous d'étendre ou de définir le thème AppCompat et d'utiliser app:backgroundTint au lieu de android:backgroundTint .

Exemple:

<android.support.design.widget.FloatingActionButton 
    xmlns:app="http://schemas.android.com/apk/res-auto"
    android:id="@+id/fab"
    android:layout_width="wrap_content"
    android:layout_height="wrap_content"
    android:layout_margin="16dp"
    android:src="@drawable/icon"
    app:backgroundTint="@color/accent"
    app:borderWidth="0dp" />




android-support-design